// SubScannerMan.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include <windows.h>
#include <commdlg.h>
#include <shlobj.h>
#include <Cderr.h>
#include "..\Include\TypeDefinition.h"
#include "..\Include\DefTwainMan.h"
#include "..\Include\Win32Library.h"
#include "..\Include\SubScannerMan.h"
#define MOSTBRIGHT 0xff
// "This function or variable may be unsafe."\Ȃ
#pragma warning(disable : 4996)



void SubMessageOut(HWND hStatusBar, wchar_t* wszStatusText)
{
	// r[v炷
	MessageBeep(MB_OK);
	// Xe[^XEBhEɕ\B
	// wParam = iPart | uType;
	// lParam = pszText;
	SendMessage(hStatusBar, SB_SETTEXT, SB_SIMPLEID | SBT_NOBORDERS, CAST(LPARAM, wszStatusText));
}

// bitmapʂɓ]
BOOL FnDrawBitmap(HWND hMainWnd, HBITMAP hBitmap, wchar_t* wszErrorText)
{
	HDC     hWinDeviceContext;
	RECT    strWinRect;
	BITCOPYPACK    strBitCopyPack;
	float   fWinWidth;
	float   fWinHeight;
	HDC     hBmpDeviceContext;
	float   fBmpWidth;
	float   fBmpHeight;
	BITMAP  strBitmap;
	BOOL	bResultState;

	// XN[N[Ă`
	//InvalidateRect(hMainWnd, NULL, TRUE);
	bResultState = FnGetClientRect(hMainWnd, &strWinRect, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	strBitCopyPack.nDstPosX = 0;
	strBitCopyPack.nDstPosY = 0;
	strBitCopyPack.nDstWidth = strWinRect.right - strWinRect.left;
	fWinWidth = CAST(float, strBitCopyPack.nDstWidth);
	strBitCopyPack.nDstHeight = strWinRect.bottom - strWinRect.top - STATUSBARHEIGHT;
	fWinHeight = CAST(float, strBitCopyPack.nDstHeight);
	bResultState = FnGetDC(hMainWnd, &hWinDeviceContext, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	bResultState = FnGetObject(hBitmap, &strBitmap, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	strBitCopyPack.nSrcPosX = 0;
	strBitCopyPack.nSrcPosY = 0;
	strBitCopyPack.nSrcWidth = strBitmap.bmWidth;
	fBmpWidth = CAST(float, strBitCopyPack.nSrcWidth);
	strBitCopyPack.nSrcHeight = strBitmap.bmHeight;
	fBmpHeight = CAST(float, strBitCopyPack.nSrcHeight);
	if ((fWinWidth / fBmpWidth) < (fWinHeight / fBmpHeight))
	{
		strBitCopyPack.nDstHeight = CAST(int, fBmpHeight * (fWinWidth / fBmpWidth));
	}
	else
	{
		strBitCopyPack.nDstWidth = CAST(int, fBmpWidth * (fWinHeight / fBmpHeight));
	}

	bResultState = FnCreateCompatibleDC(hWinDeviceContext, &hBmpDeviceContext, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	bResultState = FnSelectObject(hBmpDeviceContext, hBitmap, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	bResultState = FnStretchBlt(hBmpDeviceContext, hWinDeviceContext, &strBitCopyPack, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	bResultState = FnDeleteDC(hBmpDeviceContext, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	bResultState = FnReleaseDC(hMainWnd, hWinDeviceContext, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	wcscpy(wszErrorText, L"łB");
	return TRUE;
}

void SubGetErrorMessage(DWORD ulErrorCode, wchar_t* wszErrorMessage)
{
	wchar_t* pwchErrMessagePtr;

	//G[\쐬
	FormatMessage
	(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | // ulong   ulFlags: ς݂̃bZ[Wi[Ă̂ɏ\ȃTCỸobt@IɊ蓖Ă܂
		FORMAT_MESSAGE_FROM_SYSTEM |  // VXebZ[We[u\[Xgp悤v܂ 
		FORMAT_MESSAGE_IGNORE_INSERTS, // ߍݑ}͖ߍ܂ꂸAbZ[W`̂܂܃obt@ɏo͂܂B
		NULL, // PCVOID  pSource: ̃p[^͖܂
		ulErrorCode,  // ulong   ulMessageID: 32rbg̃bZ[WIDw肵܂
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // ulong   ulLanguageID: w肳ꂽIDƈv郁bZ[Wgp܂
		CAST(LPTSTR, &pwchErrMessagePtr), // PTSTR   pszBuffer: PVOID^ϐ̃AhXw肵܂B̊֐́ALocalAlloc֐găobt@IɊmۂ܂
		0, // ulong   nSize: obt@̍ŏTCYAoCgiUnicodeł̏ꍇ͕jŎw肵܂
		NULL // va_list* Arguments: }A32rbgl̔zւ̃|C^ƂĎw肵܂B
	);
	wcscpy(wszErrorMessage, pwchErrMessagePtr);
	LocalFree(pwchErrMessagePtr);
}

// puchBitmapBufPtrmewĂ̂delete邱
BOOL FnCopyBitmap(HBITMAP hSrcBitmap, BITMAPPACK* pstrDstBitmapPackPtr, wchar_t* wszErrorText)
{
	BITMAPFILEHEADER   strDstBitmapFileHeader; // 14bytes
	BITMAPINFOHEADER* pstrSrcBitmapInfoHeaderPtr; // 40bytes
	uchar* puchSrcBitmapPtr;
	uchar* puchSrcImagePtr;
	int		nSrcStride;
	int 	nSrcImageSize;
	int		nDstBufSize;
	BOOL	bResultState;

	bResultState = FnGlobalLock(hSrcBitmap, CAST(void**, &pstrSrcBitmapInfoHeaderPtr), wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	puchSrcBitmapPtr = CAST(uchar*, pstrSrcBitmapInfoHeaderPtr);
	puchSrcImagePtr = puchSrcBitmapPtr + sizeof(BITMAPINFOHEADER);
	bResultState = FnCreateDIBSection(pstrSrcBitmapInfoHeaderPtr, &pstrDstBitmapPackPtr->hBitmap, &pstrDstBitmapPackPtr->puchBitmapImagePtr, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	nSrcStride = SubGetStride(pstrSrcBitmapInfoHeaderPtr->biWidth, pstrSrcBitmapInfoHeaderPtr->biBitCount);
	nSrcImageSize = nSrcStride * (pstrSrcBitmapInfoHeaderPtr->biHeight);
	memmove(pstrDstBitmapPackPtr->puchBitmapImagePtr, puchSrcImagePtr, nSrcImageSize);
	memset(CAST(char*, &strDstBitmapFileHeader), 0x00, sizeof(BITMAPFILEHEADER));
	nDstBufSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + nSrcImageSize;
	strDstBitmapFileHeader.bfType = BITMAPTYPE;
	strDstBitmapFileHeader.bfSize = nDstBufSize;
	strDstBitmapFileHeader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	if (pstrDstBitmapPackPtr->puchBitmapBufPtr)
	{
		delete[] pstrDstBitmapPackPtr->puchBitmapBufPtr;
		pstrDstBitmapPackPtr->puchBitmapBufPtr = 0;
	}
	pstrDstBitmapPackPtr->puchBitmapBufPtr = new uchar[nDstBufSize];
	if (!pstrDstBitmapPackPtr->puchBitmapBufPtr)
	{
		wcscpy(wszErrorText, L"̈mۂł܂B");
		return FALSE;
	}
	memmove(pstrDstBitmapPackPtr->puchBitmapBufPtr, CAST(uchar*, &strDstBitmapFileHeader), sizeof(BITMAPFILEHEADER));
	memmove(pstrDstBitmapPackPtr->puchBitmapBufPtr + sizeof(BITMAPFILEHEADER), puchSrcBitmapPtr, sizeof(BITMAPINFOHEADER) + nSrcImageSize);
	bResultState = FnGlobalUnlock((void*)hSrcBitmap, wszErrorText);
	// Ȃ̂ɃG[ɂȂ
	if (!bResultState)
	{
		return FALSE;
	}
	wcscpy(wszErrorText, L"łB");
	return TRUE;
}

int SubGetStride(long lWidth, short sBitCount)
{
	long    lWorkStride;
	int     nStride;   // y[X

	// >> 3 : rbg˃oCg
	lWorkStride = (lWidth * sBitCount) >> 3;

	// ̃C̃f[^͂Sɔ{ɑĂȂ
	// ␳ĂSɔ{ɑB
	if (lWorkStride & 0x03)
	{
		// >> 2  ŜPɂ
		// << 2  S{ɂ
		nStride = ((lWorkStride >> 2) + 1) << 2;
	}
	// ̃C̃f[^͂Sɔ{ɑĂ
	// ␳ȂB
	else
	{
		nStride = lWorkStride;
	}
	// nStride: ␳ꂽrbg}bv̉̃oCg
	return nStride;
}

BOOL FnDrawRectangle(HWND hMainWnd, RECT* pstrRectPackPtr, wchar_t* wszErrorText)
{
	HDC         hDeviceContext;
	HPEN		hPen;
	BOOL        bResultState;

	bResultState = FnGetDC(hMainWnd, &hDeviceContext, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}

	hPen = CreatePen(PS_SOLID, PENWIDTH, RGB(0, 0, 0));
	SelectObject(hDeviceContext, hPen);
	SelectObject(hDeviceContext, GetStockObject(NULL_BRUSH));
	Rectangle(hDeviceContext, pstrRectPackPtr->left, pstrRectPackPtr->top, pstrRectPackPtr->right, pstrRectPackPtr->bottom);
	DeleteObject(hPen);
	bResultState = FnReleaseDC(hMainWnd, hDeviceContext, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	wcscpy(wszErrorText, L"łB");
	return TRUE;
}

BOOL FnChangeBitmap(BITMAPPACK* pstrBitmapPackPtr, int nIlluminance, int nContrast, wchar_t* wszErrorText)
{
	BITMAPFILEHEADER* pstrBitmapFileHeaderPtr; // 14bytes
	BITMAPINFOHEADER* pstrBitmapInfoHeaderPtr; // 40bytes
	uchar* puchFileImagePtr;
	uchar* puchBitmapImagePtr;
	int			nImageHeight;
	int			nImageStride;
	int			nImageSize;
	int			nImageIndex;
	uchar       uchWorkImage;
	BOOL		bResultState;

	if (!pstrBitmapPackPtr->puchBitmapBufPtr)
	{
		wcscpy(wszErrorText, L"ɉ摜荞ŉ");
		return FALSE;
	}
	pstrBitmapFileHeaderPtr = CAST(BITMAPFILEHEADER*, pstrBitmapPackPtr->puchBitmapBufPtr);
	pstrBitmapInfoHeaderPtr = CAST(BITMAPINFOHEADER*, (pstrBitmapPackPtr->puchBitmapBufPtr + sizeof(BITMAPFILEHEADER)));
	puchFileImagePtr = pstrBitmapPackPtr->puchBitmapBufPtr + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	nImageHeight = pstrBitmapInfoHeaderPtr->biHeight;
	nImageStride = SubGetStride(pstrBitmapInfoHeaderPtr->biWidth, pstrBitmapInfoHeaderPtr->biBitCount);
	nImageSize = nImageStride * nImageHeight;
	puchBitmapImagePtr = new uchar[nImageSize];
	if (!puchBitmapImagePtr)
	{
		wcscpy(wszErrorText, L"̈mۂł܂");
		return FALSE;
	}
	for (nImageIndex = 0; nImageIndex < nImageSize; nImageIndex++)
	{
		uchWorkImage = SubChangeContrast(puchFileImagePtr[nImageIndex], nContrast);
		puchBitmapImagePtr[nImageIndex] = SubChangeIlluminance(uchWorkImage, nIlluminance);
	}
	if (pstrBitmapPackPtr->hBitmap)
	{
		bResultState = FnDeleteObject(pstrBitmapPackPtr->hBitmap, wszErrorText);
		if (!bResultState)
		{
			return FALSE;
		}
		pstrBitmapPackPtr->hBitmap = 0;
	}
	bResultState = FnCreateDIBSection(pstrBitmapInfoHeaderPtr, &pstrBitmapPackPtr->hBitmap, &pstrBitmapPackPtr->puchBitmapImagePtr, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	memmove(pstrBitmapPackPtr->puchBitmapImagePtr, puchBitmapImagePtr, nImageSize);
	delete[] puchBitmapImagePtr;
	wcscpy(wszErrorText, L"łB");
	return TRUE;
}

void SubMessageClear(HWND hStatusBar)
{
	// Xe[^XEBhEɕ\B
	// wParam = iPart | uType;
	// lParam = pszText;
	SendMessage(hStatusBar, SB_SETTEXT, SB_SIMPLEID | SBT_NOBORDERS, CAST(LPARAM, L""));
}

// bitmapt@CBITMAPPACK
// pstrBitmapInfoPackPtr->puchOldImagePtrneŵŕKdelete[]邱
BOOL FnGetBitmap(wchar_t* wszOpenFileName, BITMAPPACK* pstrBitmapPackPtr, wchar_t* wszErrorText)
{
	int		nBufferSize;
	BITMAPINFOHEADER* pstrBitmapInfoHeaderPtr; // 40bytes
	uchar* puchImagePtr;
	int		nStride;
	int		nImageSize;
	BOOL	bResultState;

	bResultState = SubChekBMPName(wszOpenFileName);
	if (!bResultState)
	{
		wcscpy(wszErrorText, L"gq.bmpł܂B");
		return FALSE;
	}
	bResultState = SubReadText(wszOpenFileName, CAST(wchar_t**, &(pstrBitmapPackPtr->puchBitmapBufPtr)), &nBufferSize, FALSE, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	pstrBitmapInfoHeaderPtr = CAST(BITMAPINFOHEADER*, (pstrBitmapPackPtr->puchBitmapBufPtr + sizeof(BITMAPFILEHEADER)));
	puchImagePtr = pstrBitmapPackPtr->puchBitmapBufPtr + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	nStride = SubGetStride(pstrBitmapInfoHeaderPtr->biWidth, pstrBitmapInfoHeaderPtr->biBitCount);
	nImageSize = nStride * pstrBitmapInfoHeaderPtr->biHeight;
	bResultState = FnCreateDIBSection(pstrBitmapInfoHeaderPtr, &pstrBitmapPackPtr->hBitmap, &pstrBitmapPackPtr->puchBitmapImagePtr, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	memmove(pstrBitmapPackPtr->puchBitmapImagePtr, puchImagePtr, nImageSize);
	wcscpy(wszErrorText, L"łB");
	return TRUE;
}

// ePixel̃RgXgグ
uchar SubChangeContrast(int nPixel, int nRiseValue)
{
	int	nReturnValue;

	nReturnValue = (nPixel - nRiseValue) * CAST(int, CAST(double, MOSTBRIGHT) / CAST(double, MOSTBRIGHT - nRiseValue * 2));
	if (nReturnValue < 0)
	{
		nReturnValue = 0;
	}
	else if (nReturnValue > MOSTBRIGHT)
	{
		nReturnValue = MOSTBRIGHT;
	}
	return CAST(uchar, nReturnValue);
}

// ePixel̋Pxグ
uchar SubChangeIlluminance(int nPixel, int nRiseValue)
{
	int	nReturnValue;

	nReturnValue = nPixel + nRiseValue;
	if (nReturnValue < 0)
	{
		nReturnValue = 0;
	}
	else if (nReturnValue > MOSTBRIGHT)
	{
		nReturnValue = MOSTBRIGHT;
	}
	return CAST(uchar, nReturnValue);
}

// gq".txt"ŖꍇAUԂ
BOOL SubChekTXTName(wchar_t* wszGraphicsName)
{
	int		nFileSize;
	int		nIndex;
	BOOL	bResultState;

	bResultState = TRUE;
	nFileSize = wcslen(wszGraphicsName);
	nIndex = nFileSize - 4;
	if (wszGraphicsName[nIndex] != L'.')
	{
		bResultState = FALSE;
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'T')
			&& (wszGraphicsName[nIndex] != L't'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'X')
			&& (wszGraphicsName[nIndex] != L'x'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'T')
			&& (wszGraphicsName[nIndex] != L't'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if (wszGraphicsName[nIndex] != L'\x00')
		{
			bResultState = FALSE;
		}
	}
	return bResultState;
}

// gq".bmp"ŖꍇAUԂ
BOOL SubChekBMPName(wchar_t* wszGraphicsName)
{
	int		nFileSize;
	int		nIndex;
	BOOL	bResultState;

	bResultState = TRUE;
	nFileSize = wcslen(wszGraphicsName);
	nIndex = nFileSize - 4;
	if (wszGraphicsName[nIndex] != L'.')
	{
		bResultState = FALSE;
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'B')
			&& (wszGraphicsName[nIndex] != L'b'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'M')
			&& (wszGraphicsName[nIndex] != L'm'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'P')
			&& (wszGraphicsName[nIndex] != L'p'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if (wszGraphicsName[nIndex] != L'\x00')
		{
			bResultState = FALSE;
		}
	}
	return bResultState;
}

// gq".jpg"ŖꍇAUԂ
BOOL SubChekJPGName(wchar_t* wszGraphicsName)
{
	int		nFileSize;
	int		nIndex;
	BOOL	bResultState;

	bResultState = TRUE;
	nFileSize = wcslen(wszGraphicsName);
	nIndex = nFileSize - 4;
	if (wszGraphicsName[nIndex] != L'.')
	{
		bResultState = FALSE;
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'J')
			&& (wszGraphicsName[nIndex] != L'j'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'P')
			&& (wszGraphicsName[nIndex] != L'p'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'G')
			&& (wszGraphicsName[nIndex] != L'g'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if (wszGraphicsName[nIndex] != L'\x00')
		{
			bResultState = FALSE;
		}
	}
	return bResultState;
}

// gq".gif"ŖꍇAUԂ
BOOL SubChekGIFName(wchar_t* wszGraphicsName)
{
	int		nFileSize;
	int		nIndex;
	BOOL	bResultState;

	bResultState = TRUE;
	nFileSize = wcslen(wszGraphicsName);
	nIndex = nFileSize - 4;
	if (wszGraphicsName[nIndex] != L'.')
	{
		bResultState = FALSE;
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'G')
			&& (wszGraphicsName[nIndex] != L'g'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'I')
			&& (wszGraphicsName[nIndex] != L'i'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'F')
			&& (wszGraphicsName[nIndex] != L'f'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if (wszGraphicsName[nIndex] != L'\x00')
		{
			bResultState = FALSE;
		}
	}
	return bResultState;
}

// gq".tiff"ŖꍇAUԂ
BOOL SubChekTIFFName(wchar_t* wszGraphicsName)
{
	int		nFileSize;
	int		nIndex;
	BOOL	bResultState;

	bResultState = TRUE;
	nFileSize = wcslen(wszGraphicsName);
	nIndex = nFileSize - 4;
	if (wszGraphicsName[nIndex] != L'.')
	{
		bResultState = FALSE;
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'T')
			&& (wszGraphicsName[nIndex] != L't'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'I')
			&& (wszGraphicsName[nIndex] != L'i'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'F')
			&& (wszGraphicsName[nIndex] != L'f'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if (wszGraphicsName[nIndex] != L'\x00')
		{
			bResultState = FALSE;
		}
	}
	return bResultState;
}

// gq".png"ŖꍇAUԂ
BOOL SubChekPNGName(wchar_t* wszGraphicsName)
{
	int		nFileSize;
	int		nIndex;
	BOOL	bResultState;

	bResultState = TRUE;
	nFileSize = wcslen(wszGraphicsName);
	nIndex = nFileSize - 4;
	if (wszGraphicsName[nIndex] != L'.')
	{
		bResultState = FALSE;
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'P')
			&& (wszGraphicsName[nIndex] != L'p'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'N')
			&& (wszGraphicsName[nIndex] != L'n'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'G')
			&& (wszGraphicsName[nIndex] != L'g'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if (wszGraphicsName[nIndex] != L'\x00')
		{
			bResultState = FALSE;
		}
	}
	return bResultState;
}

// gq".ico"ŖꍇAUԂ
BOOL SubChekICOName(wchar_t* wszGraphicsName)
{
	int		nFileSize;
	int		nIndex;
	BOOL	bResultState;

	bResultState = TRUE;
	nFileSize = wcslen(wszGraphicsName);
	nIndex = nFileSize - 4;
	if (wszGraphicsName[nIndex] != L'.')
	{
		bResultState = FALSE;
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'I')
			&& (wszGraphicsName[nIndex] != L'i'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'C')
			&& (wszGraphicsName[nIndex] != L'c'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if ((wszGraphicsName[nIndex] != L'O')
			&& (wszGraphicsName[nIndex] != L'o'))
		{
			bResultState = FALSE;
		}
	}
	if (bResultState)
	{
		nIndex++;
		if (wszGraphicsName[nIndex] != L'\x00')
		{
			bResultState = FALSE;
		}
	}
	return bResultState;
}

// ֐̒Ń[mۂ̂ŁAŕK[J邱ƁB
BOOL SubReadText(wchar_t* wszOpenFileName, wchar_t** pwszOpenFileBufferPtr, int* pnOpenFileBufferSizePtr, BOOL bConvFlg, wchar_t* wszErrorText)
{
	HANDLE		hOpenFileHandle;
	//	wchar_t*	wszOpenFileBuffer;
	char* szOpenFileClone;
	QUADWORD	unnOpenFileBufferSize;
	BOOL        bUniCodeFlag;
	BOOL        bResultState;

	// ǂݎpt@CJB
	bResultState = FnGetOpenFileHandle(&hOpenFileHandle, wszOpenFileName, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	// t@C̑傫擾B
	bResultState = FnGetFileSize(hOpenFileHandle, &unnOpenFileBufferSize, wszErrorText);
	if (!bResultState)
	{
		CloseHandle(hOpenFileHandle);
		return FALSE;
	}

	// t@C̑傫ߑł邩ۂׂB
	else if (unnOpenFileBufferSize.strQuadWord.ulHigh)
	{
		wsprintf(wszErrorText, L"t@C%s̃TCY傫߂܂", wszOpenFileName);
		CloseHandle(hOpenFileHandle);
		return FALSE;
	}
	else
	{
		// ǂݎőoCgݒ肷
		*pnOpenFileBufferSizePtr = unnOpenFileBufferSize.strQuadWord.ulLow;
	}
	// t@C̓ǂݍݗpmۂ
	*pnOpenFileBufferSizePtr = unnOpenFileBufferSize.strQuadWord.ulLow;
	szOpenFileClone = new char[*pnOpenFileBufferSizePtr];
	if (!szOpenFileClone)
	{
		wsprintf(wszErrorText, L"t@C%s̓ǂݍݗpmۂ邱Ƃł܂B", wszOpenFileName);
		return FALSE;
	}
	// t@Cǂݍ
	*pwszOpenFileBufferPtr = CAST(wchar_t*, szOpenFileClone);
	bResultState = FnReadFile(hOpenFileHandle, wszOpenFileName, *pwszOpenFileBufferPtr, CAST(ulong*, pnOpenFileBufferSizePtr), wszErrorText);
	if (!bResultState)
	{
		delete[] szOpenFileClone;
		CloseHandle(hOpenFileHandle);
		return FALSE;
	}
	else
	{
		CloseHandle(hOpenFileHandle);
	}
	if (bConvFlg)
	{
		// ǂݍ񂾃eLXgUTF-16ł邩ۂ𒲂ׂ
		// 0xFF 0xFE: byte order mark of UTF-16
		bUniCodeFlag = ((*pwszOpenFileBufferPtr)[0] == BOMCODE);
		// ǂݍ񂾃eLXgUTF-16ł邩ۂ𒲂ׂ
		// 0xFF 0xFE: byte order mark of UTF-16
		if (bUniCodeFlag)
		{
			// >>= 1FoCg˃[h
			(*pnOpenFileBufferSizePtr) >>= 1;
		}
		// ǂݍ܂ꂽeLXgASCIIłB
		else
		{
			// ̂Q{̗̈mۂ
			// 擪BOMCODEtB
			(*pwszOpenFileBufferPtr) = new wchar_t[(*pnOpenFileBufferSizePtr + 1)];
			if (!(*pwszOpenFileBufferPtr))
			{
				wsprintf(wszErrorText, L"t@C%s̓ǂݍݗpmۂ邱Ƃł܂B", wszOpenFileName);
				delete[] szOpenFileClone;
				CloseHandle(hOpenFileHandle);
				return FALSE;
			}
			// ǂݍ܂ꂽeLXgUTF-16ɕϊ
			// unnOpenFileBufferSize.strQuadWord.ulLow: }bṽoCg
			// &nOpenFileBufferSize: obt@ɏ܂ꂽCh̐Ԃ܂B
			bResultState = FnMultiByte2WideChar(szOpenFileClone, unnOpenFileBufferSize.strQuadWord.ulLow, (*pwszOpenFileBufferPtr + 1), &(*pnOpenFileBufferSizePtr), wszErrorText);
			if (!bResultState)
			{
				delete[] szOpenFileClone;
				delete[] * pwszOpenFileBufferPtr;
				CloseHandle(hOpenFileHandle);
				return FALSE;
			} // if (!bResultState)
			delete[] szOpenFileClone;
			*pwszOpenFileBufferPtr[0] = BOMCODE;
			(*pnOpenFileBufferSizePtr)++;
		}
	}
	CloseHandle(hOpenFileHandle);
	return TRUE;
}

// ʓIȃ_CAO {bNX֐̎sɔŐṼG[܂B
void SubGetDialogErrorText(DWORD ulErrorCode, wchar_t* wszErrorText)
{
	switch (ulErrorCode)
	{
	//case CDERR_CANCELLATION:
	//	wcscpy(wszErrorText, L"LZ܂B");
	//	break;
	case CDERR_DIALOGFAILURE:
		wcscpy(wszErrorText, L"_CAO{bNX쐬ł܂łBDialogBox ֐ɑ΂R_CAO{bNX֐̌ĂяoɎs܂BƂ΁AR_CAO{bNX֐ĂяoۂɖȃEBhEnhw肷ƁA̒l܂B");
		break;
	case CDERR_FINDRESFAILURE:
		wcscpy(wszErrorText, L"\[XȂ̂ŁAR_CAO{bNX֐s܂");
		break;
	case CDERR_INITIALIZATION:
		wcscpy(wszErrorText, L"̍ۂɃR_CAO{bNX֐s܂BƂ΁As̏ꍇɔ܂B");
		break;
	case CDERR_LOADRESFAILURE:
		wcscpy(wszErrorText, L"R_CAO{bNX֐́Aw肳ꂽ\[X̃[hɎs܂");
		break;
	case CDERR_LOADSTRFAILURE:
		wcscpy(wszErrorText, L"R_CAO{bNX֐́Aw肳ꂽ̃[hɎs܂");
		break;
	case CDERR_LOCKRESFAILURE:
		wcscpy(wszErrorText, L"R_CAO{bNX֐́Aw肳ꂽ\[X̃bNɎs܂");
		break;
	case CDERR_MEMALLOCFAILURE:
		wcscpy(wszErrorText, L"R_CAO{bNX֐́A̍\̗p̃蓖Ăs܂ł");
		break;
	case CDERR_MEMLOCKFAILURE:
		wcscpy(wszErrorText, L"R_CAO{bNX֐́AnhɊ֘AtĂ郁bNł܂ł");
		break;
	case CDERR_NOHINSTANCE:
		wcscpy(wszErrorText, L"YR_CAO{bNXp̏\̂ Flags o ENABLETEMPLATE tOZbgĂ܂AΉCX^Xnh񋟂܂ł");
		break;
	case CDERR_NOHOOK:
		wcscpy(wszErrorText, L"YR_CAO{bNXp̏\̂ Flags o ENABLEHOOK tOZbgĂ܂AΉtbNvV[Ww|C^񋟂܂ł");
		break;
	case CDERR_NOTEMPLATE:
		wcscpy(wszErrorText, L"YR_CAO{bNXp̏\̂ Flags o ENABLETEMPLATE tOZbgĂ܂AΉev[g񋟂܂ł");
		break;
	case CDERR_REGISTERMSGFAIL:
		wcscpy(wszErrorText, L"R_CAO{bNX֐Ăяo RegisterWindowMessage ֐AG[R[hԂ܂");
		break;
	case CDERR_STRUCTSIZE:
		wcscpy(wszErrorText, L"YR_CAO{bNXp̏\̂ lStructSize oł");
		break;
	default:
		wsprintf(wszErrorText, L"RsȃG[ł:%0lx", ulErrorCode);
		break;
	}
}

BOOL FnSaveBitmap(BITMAPPACK* pstrBitmapPackPtr, wchar_t* wszGraphicsName, wchar_t* wszErrorText)
{
	BITMAPFILEHEADER* pstrBitmapFileHeaderPtr; // 14bytes
	BITMAPINFOHEADER* pstrBitmapInfoHeaderPtr; // 40bytes
	HANDLE  hSaveFileHandle;
	int		nHeaderSize;
	int		nStride;
	int		nImageSize;
	BOOL	bResultState;

	bResultState = SubChekBMPName(wszGraphicsName);
	if (!bResultState)
	{
		wcscpy(wszErrorText, L"gq.bmpł܂B");
		return FALSE;
	}
	bResultState = FnGetSaveFileHandle(&hSaveFileHandle, wszGraphicsName, wszErrorText);
	if (!bResultState)
	{
		return FALSE;
	}
	pstrBitmapFileHeaderPtr = CAST(BITMAPFILEHEADER*, pstrBitmapPackPtr->puchBitmapBufPtr);
	pstrBitmapInfoHeaderPtr = CAST(BITMAPINFOHEADER*, pstrBitmapPackPtr->puchBitmapBufPtr + sizeof(BITMAPFILEHEADER));
	nHeaderSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	nStride = SubGetStride(pstrBitmapInfoHeaderPtr->biWidth, pstrBitmapInfoHeaderPtr->biBitCount);
	nImageSize = nStride * pstrBitmapInfoHeaderPtr->biHeight;
	bResultState = FnWriteFile(hSaveFileHandle, wszGraphicsName, CAST(wchar_t*, pstrBitmapPackPtr->puchBitmapBufPtr), nHeaderSize, wszErrorText);
	if (!bResultState)
	{
		CloseHandle(hSaveFileHandle);
		return FALSE;
	}
	// puchBitmapImagePtr ͕\ĂҏW̃C[W
	// puchBitmapBufPtr + nHeaderSize ͓ǂݍ܂ꂽҏWÕC[W
	bResultState = FnWriteFile(hSaveFileHandle, wszGraphicsName, CAST(wchar_t*, pstrBitmapPackPtr->puchBitmapImagePtr), nImageSize, wszErrorText);
	if (!bResultState)
	{
		CloseHandle(hSaveFileHandle);
		return FALSE;
	}
	CloseHandle(hSaveFileHandle);
	wcscpy(wszErrorText, L"łB");
	return TRUE;
}

void FnBackBitmap(BITMAPPACK* pstrBitmapPackPtr)
{
	BITMAPFILEHEADER* pstrBitmapFileHeaderPtr; // 14bytes
	BITMAPINFOHEADER* pstrBitmapInfoHeaderPtr; // 40bytes
	uchar* puchImagePtr;
	int		nStride;
	int		nImageSize;

	pstrBitmapFileHeaderPtr = CAST(BITMAPFILEHEADER*, pstrBitmapPackPtr->puchBitmapBufPtr);
	pstrBitmapInfoHeaderPtr = CAST(BITMAPINFOHEADER*, pstrBitmapPackPtr->puchBitmapBufPtr + sizeof(BITMAPFILEHEADER));
	puchImagePtr = pstrBitmapPackPtr->puchBitmapBufPtr + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	nStride = SubGetStride(pstrBitmapInfoHeaderPtr->biWidth, pstrBitmapInfoHeaderPtr->biBitCount);
	nImageSize = nStride * pstrBitmapInfoHeaderPtr->biHeight;
	memmove(pstrBitmapPackPtr->puchBitmapImagePtr, puchImagePtr, nImageSize);
}
